/*****************************************************************************

        ToolsSse2.h
        Author: Laurent de Soras, 2011

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*Tab=3***********************************************************************/



#if ! defined (ToolsSse2_HEADER_INCLUDED)
#define	ToolsSse2_HEADER_INCLUDED

#if defined (_MSC_VER)
	#pragma once
	#pragma warning (4 : 4250)
#endif



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#include	<emmintrin.h>



class ToolsSse2
{

/*\\\ PUBLIC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

public:

	static __forceinline __m128i
	               loada_8_16ml (const void *msb_ptr, const void *lsb_ptr);
	static __forceinline void
	               storea_8_16ml (void *msb_ptr, void *lsb_ptr, __m128i val, __m128i mask_lsb);
	static __forceinline void
	               storea_8_16ml_partial (void *msb_ptr, void *lsb_ptr, __m128i val, __m128i mask_lsb, __m128i mask_store);
	static __forceinline __m128i
	               create_store_mask (int nbr_pix);
	static __forceinline void
	               add_x16_s32 (__m128i &dst0, __m128i &dst1, __m128i src, __m128i msw);
	static __forceinline void
	               mul_s16_s16_s32 (__m128i &dst0, __m128i &dst1, __m128i src, __m128i coef);
	static __forceinline __m128i
	               mul_s32_s15_s16 (__m128i src0, __m128i src1, __m128i coef);
	static __forceinline void
	               mac_s16_s16_s32 (__m128i &dst0, __m128i &dst1, __m128i src, __m128i coef);
	static __forceinline __m128i
	               mullo_epi32 (const __m128i &a, const __m128i &b);
	static __forceinline __m128i
	               pack_epi16 (__m128i a, __m128i b);
	static __forceinline __m128i
	               select (const __m128i &cond, const __m128i &v_t, const __m128i &v_f);
	static __forceinline __m128i
	               select_16_equ (const __m128i &lhs, const __m128i &rhs, const __m128i &v_t, const __m128i &v_f);
	static __forceinline __m128i
	               limit_epi16 (const __m128i &x, const __m128i &mi, const __m128i &ma);
	static __forceinline __m128i
	               abs_dif_epu16 (const __m128i &a, const __m128i &b);
	static __forceinline __m128i
	               abs_dif_epi16 (const __m128i &a, const __m128i &b);
	template <class T>
	static __forceinline bool
	               check_ptr_align (T *ptr);

	typedef __declspec (align (16)) int VectI32 [4];

	static const VectI32
	               _zero;
	static const VectI32
	               _c16_8000;
	static const VectI32
	               _c32_00008000;
	static const VectI32
	               _c32_0000ffff;
	static const VectI32
	               _mask_lo64;



/*\\\ PROTECTED \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

protected:



/*\\\ PRIVATE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:



/*\\\ FORBIDDEN MEMBER FUNCTIONS \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:

						ToolsSse2 ();
						ToolsSse2 (const ToolsSse2 &other);
	virtual			~ToolsSse2 () {}
	ToolsSse2 &		operator = (const ToolsSse2 &other);
	bool				operator == (const ToolsSse2 &other) const;
	bool				operator != (const ToolsSse2 &other) const;

};	// class ToolsSse2



#include	"ToolsSse2.hpp"



#endif	// ToolsSse2_HEADER_INCLUDED



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
